<?php

namespace App\Controllers;

use App\Models\Request;
use App\Models\Response;
use CodeIgniter\API\ResponseTrait;
use Dompdf\Dompdf;
use Exception;
use Google\Client;
use Google\Service\Drive;

class Api extends BaseController
{
    public function __construct()
    {
    }

    use ResponseTrait;

    public function index()
    {
        $response = [
            'status'   => 201,
            'error'    => null,
            'messages' => [
                'success' => 'Employee created successfully'
            ]
        ];

        print_r($response);

        //return $this->respondCreated($response);
    }

    public function generate_document()
    {
        $model = new Request();
        $model_response = new Response();
        $request = $_GET;

        $uuid = service('uuid');
        $uuid4 = $uuid->uuid4();
        $ID = $uuid4->toString();

        $data = [
            'request_id' => $ID,
            'json' => json_encode($request),
            'data_request' => date('Y-m-d H:i'),
            'authentication' => hash('sha256', "user: {$request['user']}, web: {$request['url']}, date_requested: " . date('Y-m-d H:i')),
            'user' => $request['user'],
            'url' => $request['url'],
            'type' => 1
        ];



        // echo $string;

        //$this->uploadBasic();
        //exit();        


        //$model->insert($data);
        //$ID = $model->insertID();

        //echo $ID; exit();
        if (empty($request['url']) || !isset($request['url'])) {
            $response = [
                'status'   => 203,
                'error'    => true,
                'data'     => $data,
                'messages' => [
                    'success' => 'El campo url es requerido'
                ]
            ];

            $data_response = [
                'request_id' => $ID,
                'message' => $response['messages'],
                'code' => $response['status'],
                'url' => $request['url'],
            ];

            $model_response->insert($data_response);

            return $this->respondCreated($response);
        }

        //$embed = new Embed::();        
        //$host = parse_url("https://www.youtube.com/watch?v=4YCLRpKY1cs&ab_channel=LaravelPackageTutorial", PHP_URL_HOST);
        $ip = $_SERVER['REMOTE_ADDR']; //$this->get_client_ip();

        $info = $this->getHTML($request['url'], 10);
        preg_match('/<title>([^<]+)<\/title>/i', $info, $match);
        $title = $match[0];

        $data_pdf = [
            'title' => $title,
            'ip_visitor' => $ip,
            'data' => $data,
            'html' => htmlentities($info),
            'id' => $ID
        ];
        //print_r(htmlentities($info));exit();

        $response = [
            'status'   => 201,
            'error'    => null,
            'data'     => $data,
            'messages' => [
                'success' => 'Employee created successfully'
            ]
        ];

        $data_response = [
            'request_id' => $ID,
            'message' => $response['messages'],
            'code' => $response['status'],
            'url' => $request['url'],
        ];

        //$model_response->insert($data_response);



        //return view('pdf_view', $data_pdf);


        $dompdf = new Dompdf();
        //$html = view('pdf_view', $data_pdf);
        //$html .= '<link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.2/dist/css/bootstrap.min.css" integrity="sha384-Zenh87qX5JnK2Jl0vWa8Ck2rdkQ2Bzep5IDxbcnCeuOxjzrPF/et3URy9Bv1WTRi" crossorigin="anonymous">';
        $dompdf->loadHtml(view('pdf_view', $data_pdf));
        $dompdf->setPaper('A4', 'portrait');
        $dompdf->render();
        $dompdf->stream();

        //return $this->respondCreated($response);
    }

    function getHTML($url, $timeout)
    {
        $ch = curl_init($url); // initialize curl with given url
        curl_setopt($ch, CURLOPT_USERAGENT, $_SERVER["HTTP_USER_AGENT"]); // set  useragent
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); // write the response to a variable
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true); // follow redirects if any
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout); // max. seconds to execute
        curl_setopt($ch, CURLOPT_FAILONERROR, 1); // stop when it encounters an error
        return @curl_exec($ch);
    }

    function uploadBasic()
    {
        try {
            $client = new Client();            
            $client->setClientId("803706034206-ainckph23ceu4345472ht6ft7mgbaue3.apps.googleusercontent.com");
            $client->setClientSecret("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");
            $client->setRedirectUri('http://localhost:8080/google_drive_sync');
            $client->addScope(Drive::DRIVE);
            $driveService = new Drive($client);
            $fileMetadata = new Drive\DriveFile(array(
                'name' => 'photo.jpg'
            ));
            $content = file_get_contents('./Kodit.png');
            $file = $driveService->files->create($fileMetadata, array(
                'data' => $content,
                'mimeType' => 'image/jpeg',
                'uploadType' => 'multipart',
                'fields' => 'id'
            ));
            printf("File ID: %s\n", $file->id);
            return $file->id;
        } catch (Exception $e) {
            echo "Error Message: " . $e;
        }
    }

    function download_video()
    {
        $url = "https://www.facebook.com/CuddleClones/videos/473689233322969";
        $ch = curl_init($url);
        $ua = "Mozilla/5.0 (Windows NT 10.0; WOW64; rv:70.0) Gecko/20100101 Firefox/70.0";

        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_USERAGENT, $ua);

        $html = curl_exec($ch);
        curl_close($ch);

        preg_match('#content="(https://video.*?)"#', $html, $matches);
        print_r($matches);
        // echo "URL del vídeo a descargar: $matches[1]";

        // // Descargar video
        // $url = $matches[1];
        // $video = fopen("video.mp4", "w");
        // $ch = curl_init();
        // curl_setopt($ch, CURLOPT_URL, html_entity_decode($url));
        // curl_setopt($ch, CURLOPT_FILE, $video);
        // curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        // curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        // $data = curl_exec($ch);
        // curl_close($ch);
        // fclose($video);
    }

    function get_client_ip()
    {
        $ipaddress = '';
        if (isset($_SERVER['HTTP_CLIENT_IP']))
            $ipaddress = $_SERVER['HTTP_CLIENT_IP'];
        else if (isset($_SERVER['HTTP_X_FORWARDED_FOR']))
            $ipaddress = $_SERVER['HTTP_X_FORWARDED_FOR'];
        else if (isset($_SERVER['HTTP_X_FORWARDED']))
            $ipaddress = $_SERVER['HTTP_X_FORWARDED'];
        else if (isset($_SERVER['HTTP_FORWARDED_FOR']))
            $ipaddress = $_SERVER['HTTP_FORWARDED_FOR'];
        else if (isset($_SERVER['HTTP_FORWARDED']))
            $ipaddress = $_SERVER['HTTP_FORWARDED'];
        else if (isset($_SERVER['REMOTE_ADDR']))
            $ipaddress = $_SERVER['REMOTE_ADDR'];
        else
            $ipaddress = 'UNKNOWN';
        return $ipaddress;
    }
}
