<?php

namespace App\Controllers\Catalogos;

use RolEnums;
use App\Controllers\BaseController;
use App\Models\Catalogos\tipomodel;
use App\Models\Request;


class Tipos extends BaseController
{

    public function __construct()
    {
        helper('application');
        // Config('Config\\Enums\\RolEnums');
    }

    public function index()
    {
        // if(!validate_permissions(session()->get('rol_id'), 11, ActionsEnums::CONSULTAR)){
        //     return redirect()->to(base_url('pages/error-403'));
        // }
        if (session()->get('rol') != 101) {
            return redirect()->to(base_url('pages/error-403'));
        }
        $Tipo = new tipomodel();
        $datos = $Tipo->listarTipo();

        $data = [
            "datos" => $datos
        ];

        return view("catalogos/tipo", $data);
    }

    public function crear()
    {
        // if(!validate_permissions(session()->get('rol_id'), 11, ActionsEnums::CREAR)){
        //     return redirect()->to(base_url('pages/error-403'));
        // }
        if (session()->get('rol') != 101) {
            return redirect()->to(base_url('pages/error-403'));
        }

        helper(['form']);
        $validation = service('validation');
        $rules = [
            'type' => [
                'rules' => 'required|max_length[100]',
                'label' => 'Tipo',
                'errors' => [
                    'required' => 'El campo {field} es requerido',
                    'max_length' => 'El campo {field} debe contener máximo 100 caracteres',
                ]
            ]
        ];

        if (!$this->validate($rules)) {
            $session = session();
            $validation->withRequest($this->request)->run();
            $session->setFlashdata('errors', $validation->getErrors());
            return redirect()->to(base_url() . '/tipos')->withInput();
        }

        $datos = [
            'id' => 'null',
            'type' => $_POST['type']
        ];

        $Tipo = new tipomodel();
        if ($Tipo->get_tipo_id($_POST['type'])) {
            session()->setFlashdata('msg-error', 'El tipo ya se encuentra registrado, favor de validar la información');
            return redirect()->to(base_url() . '/tipos');
        }

        $respuesta = $Tipo->insertar($datos);

        if ($respuesta > 0) {
            session()->setFlashdata('msg-success', 'Operación realizada con éxito');
            return redirect()->to(base_url() . '/tipos');
        } else {
            session()->setFlashdata('msg-error', 'Ocurrio un error en la operación, favor de validar la información');
            return redirect()->to(base_url() . '/tipos');
        }
    }

    public function actualizar()
    {
        // if(!validate_permissions(session()->get('rol_id'), 11, ActionsEnums::EDITAR)){
        //     return redirect()->to(base_url('pages/error-403'));
        // }
        if (session()->get('rol') != 101) {
            return redirect()->to(base_url('pages/error-403'));
        }

        helper(['form']);
        $validation = service('validation');
        $rules = [
            'typeupdate' => [
                'rules' => 'required|max_length[100]',
                'label' => 'Tipo',
                'errors' => [
                    'required' => 'El campo {field} es requerido',
                    'max_length' => 'El campo {field} debe contener máximo 100 caracteres',
                ]
            ]
        ];

        if (!$this->validate($rules)) {
            $session = session();
            $validation->withRequest($this->request)->run();
            $session->setFlashdata('errors', $validation->getErrors());
            return redirect()->to(base_url() . '/tipos')->withInput();
        }

        $datos = [
            'id' => $_POST['idupdate'],
            'type' => $_POST['typeupdate']
        ];

        $id = $_POST['idupdate'];
        $Tipo = new tipomodel();
        if ($Tipo->get_tipo_id($_POST['typeupdate'])) {
            session()->setFlashdata('msg-error', 'El tipo ya se encuentra registrado, favor de validar la información');
            return redirect()->to(base_url() . '/tipos');
        }

        $respuesta = $Tipo->actualizar($datos, $id);

        if ($respuesta) {
            session()->setFlashdata('msg-success', 'Operación realizada con éxito');
            return redirect()->to(base_url() . '/tipos');
        } else {
            session()->setFlashdata('msg-error', 'Ocurrio un error en la operación, favor de validar la información');
            return redirect()->to(base_url() . '/tipos');
        }
    }

    public function eliminar($id)
    {
        // if(!validate_permissions(session()->get('rol_id'), 11, ActionsEnums::ELIMINAR)){
        //     return redirect()->to(base_url('pages/error-403'));
        // } 
        if (session()->get('rol') != 101) {
            return redirect()->to(base_url('pages/error-403'));
        }

        $Request = new Request();
        $validateRequest = $Request->where('id_type', $id)->get()->getResultArray();

        if (!empty($validateRequest)) {
            session()->setFlashdata('msg-error', 'No es posible eliminar el Tipo de contrato seleccionado, debido a que ya se encuentra asignado a un usuario');
            return redirect()->to(base_url('/tipos'));
        }

        $Tipo = new tipomodel();
        $data = ['id' => $id];

        $respuesta = $Tipo->eliminar($data);

        if ($respuesta) {
            session()->setFlashdata('msg-success', 'Operación realizada con éxito');
            return redirect()->to(base_url() . '/tipos');
        } else {
            session()->setFlashdata('msg-error', 'Ocurrio un error en la operación, favor de validar la información');
            return redirect()->to(base_url() . '/tipos');
        }
    }
}
