<?php

namespace App\Controllers\Documents;

use App\Controllers\BaseController;
use App\Models\Request;
use App\Models\Response;
use App\Models\Catalogos\tipomodel;
use CodeIgniter\API\ResponseTrait;
use Dompdf\Dompdf;
use CodeIgniter\I18n\Time;
use PhpOffice\PhpSpreadsheet\Spreadsheet;
use PhpOffice\PhpSpreadsheet\Writer\Xlsx;

class Generate extends BaseController
{

    public function __construct()
    {
        // helper('application');
        // Config('Config\\Enums\\ActionsEnums');     
    }

    use ResponseTrait;

    public function index()
    {
        // if(!validate_permissions(session()->get('rol_id'), 8, ActionsEnums::CONSULTAR)){
        //     return redirect()->to(base_url('pages/error-403'));
        // }
        $Request = new Request();
        $Types = new tipomodel();
        $now = new Time('now', 'America/Mexico_City', 'es_MX');
        $initialDayOfMonth = new Time($now->addMonths(0)->format('Y-m-01'), 'America/Mexico_City', 'es_MX');
        $endDayOfMonth = $initialDayOfMonth->addMonths(1)->addDays(-1);
        $page = 1;

        $data = [
            // "requests" => $Request->listar(),
            // "requests" => $Request->listar(session()->get('id'), session()->get('rol')),
            "requests" => $Request->listarDocumentos(session()->get('id'), session()->get('rol'), $initialDayOfMonth->format('Y-m-d'), $endDayOfMonth->format('Y-m-d')),
            "types" => $Types->listarTipo(),
            'initial' => $initialDayOfMonth,
            'end' => $endDayOfMonth,
            'filter' => '',
            'pager' => $Request->pager->getDetails(),
        ];

        return view("documents/generate", $data);
    }

    public function filtrarRangoFecha()
    {
        $Request = new Request();
        $Types = new tipomodel();
        $now = explode(" - ", $_GET['rangoFecha']);
        $filter = trim($_GET['filter']);
        $page = isset($_GET['page']) && !empty($_GET['page']) ? $_GET['page'] : 1;

        // if (!validate_permissions(session()->get('rol_id'), 16, ActionsEnums::CONSULTAR)) {
        //     return redirect()->to(base_url('pages/error-403'));
        // }

        $initialDayOfMonth = new Time($now[0], 'America/Mexico_City', 'es_MX');
        $endDayOfMonth = new Time($now[1], 'America/Mexico_City', 'es_MX');

        $validateRange = $initialDayOfMonth->addMonths(3);

        if ($validateRange < $endDayOfMonth) {
            session()->setFlashdata('msg-error', 'El rango máximo de búsqueda debe ser menor o igual a 3 meses');
            return redirect()->to(base_url() . '/documents/generate');
        }

        $data = [
            "requests" => $Request->listarDocumentos(session()->get('id'), session()->get('rol'), $initialDayOfMonth->format('Y-m-d'), $endDayOfMonth->format('Y-m-d'), $filter),
            "types" => $Types->listarTipo(),
            'initial' => $initialDayOfMonth,
            'end' => $endDayOfMonth,
            'filter' => $filter,
            'pager' => $Request->pager->getDetails(),
        ];

        // echo "<pre>"; print_r($data); echo "</pre>"; exit();

        return view("documents/generate", $data);
    }

    public function generate_document()
    {
        helper(['form']);
        $validation = service('validation');

        $rules = [
            'url'         => [
                'label' => 'URL',
                'rules' => 'required',
                'errors' => [
                    'required' => 'El campo {field} es requerido',
                ],
            ],

        ];

        if (!$this->validate($rules)) {
            $session = session();
            $validation->withRequest($this->request)->run();
            $session->setFlashdata('errors', $validation->getErrors());
            return redirect()->to(base_url() . '/documents');
        }

        $model = new Request();
        $model_response = new Response();
        $request = $_GET;
        $request['user'] = session()->get('name');
        $request['id_user'] = session()->get('id');

        $uuid = service('uuid');
        $uuid4 = $uuid->uuid4();
        $ID = $uuid4->toString();

        $data = [
            'request_id' => $ID,
            'json' => json_encode($request),
            'data_request' => date('Y-m-d H:i'),
            'authentication' => hash('sha256', "user: {$request['user']}, web: {$request['url']}, date_requested: " . date('Y-m-d H:i')),
            'user' => $request['user'],
            'id_user' => $request['id_user'],
            'url' => $request['url'],
            'type' => 1,
            'id_type' => $request['id_type'],
        ];

        $model->insert($data);

        //$ID = $model->insertID();

        //echo $ID; exit();
        if (empty($request['url']) || !isset($request['url'])) {
            $response = [
                'status'   => 203,
                'error'    => true,
                'data'     => $data,
                'messages' => [
                    'success' => 'El campo url es requerido'
                ]
            ];

            $data_response = [
                'request_id' => $ID,
                'message' => $response['messages'],
                'code' => $response['status'],
                'url' => $request['url'],
            ];

            $model_response->insert($data_response);

            // $response['error'] = true;
            // $response['message'] = "El campo url es requerido";
            // $response['data'] = array();
            // echo json_encode($response);
            // return false;
        }

        //$embed = new Embed::();        
        //$host = parse_url("https://www.youtube.com/watch?v=4YCLRpKY1cs&ab_channel=LaravelPackageTutorial", PHP_URL_HOST);
        $ip = $_SERVER['REMOTE_ADDR']; //$this->get_client_ip();

        $info = $this->getHTML($request['url'], 10);
        preg_match('/<title>([^<]+)<\/title>/i', $info, $match);
        $title = $match[0];

        $title_replace = str_replace("<title>", "", $title);
        $title_replace = str_replace("</title>", "", $title_replace);

        $data_pdf = [
            'title' => $title,
            'ip_visitor' => $ip,
            'data' => $data,
            'html' => htmlentities($info),
            'id' => $ID
        ];
        //print_r(htmlentities($info));exit();

        $response = [
            'status'   => 201,
            'error'    => null,
            'data'     => $data,
            'messages' => [
                'success' => 'Employee created successfully'
            ]
        ];

        $data_response = [
            'request_id' => $ID,
            'message' => $response['messages'],
            'code' => $response['status'],
            'url' => $request['url'],
            'title' => $title_replace,
        ];

        $model_response->insert($data_response);

        $dompdf = new Dompdf();
        $dompdf->loadHtml(view('pdf_view', $data_pdf));
        $dompdf->setPaper('A4', 'portrait');
        $dompdf->render();
        $dompdf->stream();
        exit();
    }

    public function editar_document()
    {
        helper(['form']);
        $validation = service('validation');

        $rules = [
            'urlUpdate'         => [
                'label' => 'URL',
                'rules' => 'required',
                'errors' => [
                    'required' => 'El campo {field} es requerido',
                ],
            ],

        ];

        if (!$this->validate($rules)) {
            $session = session();
            $validation->withRequest($this->request)->run();
            $session->setFlashdata('errors', $validation->getErrors());
            return redirect()->to(base_url() . '/documents');
        }

        $model = new Request();
        $model_response = new Response();
        $request['user'] = session()->get('name');
        $request['url'] = $_GET['urlUpdate'];

        // $uuid = service('uuid');
        // $uuid4 = $uuid->uuid4();
        // $ID = $uuid4->toString();
        $ID = $_GET['idUpdate'];

        $data = [
            // 'request_id' => $ID,
            'json' => json_encode($request),
            'data_request' => date('Y-m-d H:i'),
            'authentication' => hash('sha256', "user: {$request['user']}, web: {$request['url']}, date_requested: " . date('Y-m-d H:i')),
            'user' => $request['user'],
            'url' => $request['url'],
            'type' => 1
        ];

        // $model->insert($data);
        $model->update($ID, $data);
        //$ID = $model->insertID();

        //echo $ID; exit();
        if (empty($request['url']) || !isset($request['url'])) {
            $response = [
                'status'   => 203,
                'error'    => true,
                'data'     => $data,
                'messages' => [
                    'success' => 'El campo url es requerido'
                ]
            ];

            $data_response = [
                // 'request_id' => $ID,
                'message' => $response['messages'],
                'code' => $response['status'],
                'url' => $request['url'],
            ];

            $model_response->update($ID, $data_response);
        }

        //$embed = new Embed::();        
        //$host = parse_url("https://www.youtube.com/watch?v=4YCLRpKY1cs&ab_channel=LaravelPackageTutorial", PHP_URL_HOST);
        $ip = $_SERVER['REMOTE_ADDR']; //$this->get_client_ip();

        $info = $this->getHTML($request['url'], 10);
        preg_match('/<title>([^<]+)<\/title>/i', $info, $match);
        $title = $match[0];

        $data_pdf = [
            'title' => $title,
            'ip_visitor' => $ip,
            'data' => $data,
            'html' => htmlentities($info),
            'id' => $ID
        ];
        //print_r(htmlentities($info));exit();

        $response = [
            'status'   => 201,
            'error'    => null,
            'data'     => $data,
            'messages' => [
                'success' => 'Employee created successfully'
            ]
        ];

        $data_response = [
            // 'request_id' => $ID,
            'message' => $response['messages'],
            'code' => $response['status'],
            'url' => $request['url'],
            'title' => $title,
        ];

        // $model_response->insert($data_response);
        $model_response->update($ID, $data_response);

        $dompdf = new Dompdf();
        $dompdf->loadHtml(view('pdf_view', $data_pdf));
        $dompdf->setPaper('A4', 'portrait');
        $dompdf->render();
        $dompdf->stream();
        exit();
    }

    public function download_document()
    {
        helper(['form']);
        $validation = service('validation');

        $rules = [
            'url'         => [
                'label' => 'URL',
                'rules' => 'required',
                'errors' => [
                    'required' => 'El campo {field} es requerido',
                ],
            ],

        ];

        if (!$this->validate($rules)) {
            $session = session();
            $validation->withRequest($this->request)->run();
            $session->setFlashdata('errors', $validation->getErrors());
            return redirect()->to(base_url() . '/documents');
        }

        $model = new Request();
        $model_response = new Response();
        $request = $_GET;
        // $request['user'] = session()->get('name');

        // $uuid = service('uuid');
        // $uuid4 = $uuid->uuid4();
        // $ID = $uuid4->toString();
        $ID = $_GET['idUpdate'];

        $data = [
            // 'request_id' => $ID,
            'json' => json_encode($request),
            'data_request' => date('Y-m-d H:i'),
            'authentication' => hash('sha256', "user: {$request['user']}, web: {$request['url']}, date_requested: " . date('Y-m-d H:i')),
            'user' => $request['user'],
            'url' => $request['url'],
            'type' => 1,
        ];

        // $model->insert($data);
        // $model->update($ID, $data);
        //$ID = $model->insertID();

        //echo $ID; exit();
        if (empty($request['url']) || !isset($request['url'])) {
            $response = [
                'status'   => 203,
                'error'    => true,
                'data'     => $data,
                'messages' => [
                    'success' => 'El campo url es requerido'
                ]
            ];

            $data_response = [
                // 'request_id' => $ID,
                'message' => $response['messages'],
                'code' => $response['status'],
                'url' => $request['url'],
            ];

            // $model_response->update($ID, $data_response);
        }

        //$embed = new Embed::();        
        //$host = parse_url("https://www.youtube.com/watch?v=4YCLRpKY1cs&ab_channel=LaravelPackageTutorial", PHP_URL_HOST);
        $ip = $_SERVER['REMOTE_ADDR']; //$this->get_client_ip();

        $info = $this->getHTML($request['url'], 10);
        preg_match('/<title>([^<]+)<\/title>/i', $info, $match);
        $title = $match[0];

        $data_pdf = [
            'title' => $title,
            'ip_visitor' => $ip,
            'data' => $data,
            'html' => htmlentities($info),
            'id' => $ID
        ];
        //print_r(htmlentities($info));exit();

        $response = [
            'status'   => 201,
            'error'    => null,
            'data'     => $data,
            'messages' => [
                'success' => 'Employee created successfully'
            ]
        ];

        $data_response = [
            // 'request_id' => $ID,
            'message' => $response['messages'],
            'code' => $response['status'],
            'url' => $request['url'],
            'title' => $title,
        ];

        // $model_response->insert($data_response);
        // $model_response->update($ID, $data_response);

        $dompdf = new Dompdf();
        $dompdf->loadHtml(view('pdf_view', $data_pdf));
        $dompdf->setPaper('A4', 'portrait');
        $dompdf->render();
        $dompdf->stream();
        // $output = $dompdf->output();
        // var_dump($output);
        // file_put_contents('exportacion.pdf', $output);
        // $response['error'] = false;
        // $response['message'] = "Descargado correctamente";
        // $response['data'] = array();
        // echo json_encode($data);
        // return;
        // return $output;
        exit();
    }

    function getHTML($url, $timeout)
    {
        $ch = curl_init($url); // initialize curl with given url
        curl_setopt($ch, CURLOPT_USERAGENT, $_SERVER["HTTP_USER_AGENT"]); // set  useragent
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true); // write the response to a variable
        curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true); // follow redirects if any
        curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, $timeout); // max. seconds to execute
        curl_setopt($ch, CURLOPT_FAILONERROR, 1); // stop when it encounters an error
        return @curl_exec($ch);
    }

    function download_video()
    {
        $url = "https://www.facebook.com/CuddleClones/videos/473689233322969";
        $ch = curl_init($url);
        $ua = "Mozilla/5.0 (Windows NT 10.0; WOW64; rv:70.0) Gecko/20100101 Firefox/70.0";

        curl_setopt($ch, CURLOPT_HEADER, false);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        curl_setopt($ch, CURLOPT_USERAGENT, $ua);

        $html = curl_exec($ch);
        curl_close($ch);

        preg_match('#content="(https://video.*?)"#', $html, $matches);
        print_r($matches);
        // echo "URL del vídeo a descargar: $matches[1]";

        // // Descargar video
        // $url = $matches[1];
        // $video = fopen("video.mp4", "w");
        // $ch = curl_init();
        // curl_setopt($ch, CURLOPT_URL, html_entity_decode($url));
        // curl_setopt($ch, CURLOPT_FILE, $video);
        // curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0);
        // curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
        // $data = curl_exec($ch);
        // curl_close($ch);
        // fclose($video);
    }

    function get_client_ip()
    {
        $ipaddress = '';
        if (isset($_SERVER['HTTP_CLIENT_IP']))
            $ipaddress = $_SERVER['HTTP_CLIENT_IP'];
        else if (isset($_SERVER['HTTP_X_FORWARDED_FOR']))
            $ipaddress = $_SERVER['HTTP_X_FORWARDED_FOR'];
        else if (isset($_SERVER['HTTP_X_FORWARDED']))
            $ipaddress = $_SERVER['HTTP_X_FORWARDED'];
        else if (isset($_SERVER['HTTP_FORWARDED_FOR']))
            $ipaddress = $_SERVER['HTTP_FORWARDED_FOR'];
        else if (isset($_SERVER['HTTP_FORWARDED']))
            $ipaddress = $_SERVER['HTTP_FORWARDED'];
        else if (isset($_SERVER['REMOTE_ADDR']))
            $ipaddress = $_SERVER['REMOTE_ADDR'];
        else
            $ipaddress = 'UNKNOWN';
        return $ipaddress;
    }

    public function delete_document($id)
    {
        $model = new Request();
        $data = ['request_id' => $id];

        $respuesta = $model->eliminar($data);

        if ($respuesta) {
            session()->setFlashdata('msg-success', 'Operación realizada con éxito');
            return redirect()->to(base_url() . '/documents/generate');
        } else {
            session()->setFlashdata('msg-error', 'Ocurrio un error en la operación, favor de validar la información');
            return redirect()->to(base_url() . '/documents/generate');
        }
    }

    public function document_xlsx()
    {

        $Request = new Request();
        $Types = new tipomodel();
        $now = explode(" - ", $_GET['rangoFecha']);
        $filter = trim($_GET['filter']);

        // if (!validate_permissions(session()->get('rol_id'), 16, ActionsEnums::CONSULTAR)) {
        //     return redirect()->to(base_url('pages/error-403'));
        // }

        $initialDayOfMonth = new Time($now[0], 'America/Mexico_City', 'es_MX');
        $endDayOfMonth = new Time($now[1], 'America/Mexico_City', 'es_MX');

        $validateRange = $initialDayOfMonth->addMonths(3);

        if ($validateRange < $endDayOfMonth) {
            session()->setFlashdata('msg-error', 'El rango máximo de búsqueda debe ser menor o igual a 3 meses');
            return redirect()->to(base_url() . '/reporte/concentrado');
        }

        $data = $Request->listarDocumentos(session()->get('id'), session()->get('rol'), $initialDayOfMonth->format('Y-m-d'), $endDayOfMonth->format('Y-m-d'), $filter, false);

        $spread = new Spreadsheet();
        $sheet = $spread->getActiveSheet();
        $sheet->setTitle("Certificación de páginas web");
        $sheet->setCellValueByColumnAndRow(1, 1, "Usuario");
        $sheet->setCellValueByColumnAndRow(2, 1, "URL");
        $sheet->setCellValueByColumnAndRow(3, 1, "Título");
        $sheet->setCellValueByColumnAndRow(4, 1, "Tipo");

        $row = 2;

        foreach ($data as $asignacion) {
            $column = 1;
            $sheet->setCellValueByColumnAndRow($column, $row, $asignacion['user']);
            $column++;
            $sheet->setCellValueByColumnAndRow($column, $row, $asignacion['url']);
            $column++;
            $sheet->setCellValueByColumnAndRow($column, $row, $asignacion['title']);
            $column++;
            $sheet->setCellValueByColumnAndRow($column, $row, $asignacion['type']);
            $column++;
            $row++;
        } //$sheet->getHighestColumn();
        // exit();
        $sheet->getColumnDimensionByColumn(1)->setAutoSize(TRUE);
        $sheet->getColumnDimensionByColumn(2)->setAutoSize(TRUE);
        $sheet->getColumnDimensionByColumn(3)->setAutoSize(TRUE);
        $sheet->getColumnDimensionByColumn(4)->setAutoSize(TRUE);

        $sheet->getStyleByColumnAndRow(1, 1, 4, 1)->getFont()->setBold($weight = 1);
        $sheet->calculateColumnWidths();
        $writer = new Xlsx($spread);

        $fileName = "Certificacion de paginas web.xlsx";

        //$writer->save(base_url().'/Files/'.$fileName);
        header('Content-Type: application/vnd.openxmlformats-officedocument.spreadsheetml.shee');
        header('Content-Disposition: attachment; filename="' . $fileName . '"');
        $writer->save('php://output');
    }
}
