<?php

namespace App\Controllers\Seguridad;

use App\Controllers\BaseController;
use App\Models\Seguridad\Usuarios;
use CodeIgniter\I18n\Time;
use DateTime;

class Login extends BaseController
{
    public function index()
    {
        if (session()->get('isLoggedIn')) {
            return redirect()->to(base_url('/index'));
        }
        return view('login/index');
    }

    public function forgot_password()
    {
        if (session()->get('isLoggedIn')) {
            return redirect()->to(base_url('/index'));
        }
        return view('login/forgot-password');
    }

    public function recovery_password()
    {
        $email = $this->request->getGet('e');

        $pass = $userModel =  new Usuarios();
        $time = openssl_decrypt($this->request->getGet('t'), "AES-128-CTR", "date", 0, '1234567891011121');

        $dt   = new Time($time, 'America/Mexico_City', 'es_MX');
        $now = new Time('now', 'America/Mexico_City', 'es_MX');
        $validateTime = $dt->addDays(1);

        if ($now >= $validateTime) {
            return view('pages/error-404');
        }

        $data = $userModel->where('user_email', openssl_decrypt($email, "AES-128-CTR", "email", 0, '1234567891011121'))->first();


        if (!isset($data)) {
            return view('pages/error-404');
        }

        $data['url_recovery'] = base_url('/recovery-password') . '?e=' . $this->request->getGet('e');
        return view('login/recovery-password', $data);
    }

    public function mails_forgot()
    {
        return view('Mails/forgot');
    }

    public function auth()
    {
        helper(['form']);
        $rules = [
            'email'         => [
                'label' => 'correo',
                'rules' => 'required|min_length[4]|max_length[100]|valid_email',
                'errors' => [
                    'required' => 'El campo {field} es requerido',
                    'min_length' => 'El campo {field} debe tener una longitud mínima de {param} caracteres.',
                    'min_length' => 'El campo {field} debe tener una longitud máxima de {param} caracteres',
                    'valid_email' => 'El correo ingresado es inválido.',
                ],
            ],
            'pass'      => [
                'label' => 'contraseña',
                'rules' => 'required|min_length[4]|max_length[50]',
                'errors' => [
                    'required' => 'El campo {field} es requerido',
                    'min_length' => 'El campo {field} debe tener una longitud mínima de {param} caracteres.',
                    'min_length' => 'El campo {field} debe tener una longitud máxima de {param} caracteres',
                ],
            ]
        ];
        if ($this->validate($rules)) {
            $session = session();
            $email = $this->request->getPost('email');
            $password = $this->request->getPost('pass');
            $userModel =  new Usuarios();

            $data = $userModel->where('user_email', $email)->first();
            
            if ($data) {
                $pass = $data['password'];
                $authenticatePassword = password_verify($password, $pass);
                if ($authenticatePassword) {
                    $ses_data = [
                        'id' => $data['user_id'],
                        'name' => $data['user_name'],
                        'email' => $data['user_email'],
                        'isLoggedIn' => TRUE,
                        'rol' => $data['rol'],
                    ];
                    $session->set($ses_data);
                    return redirect()->to(base_url('/index'));
                } else {
                    $session->setFlashdata('msg', 'La contraseña es incorrecta.');
                    return redirect()->to(base_url('/'));
                }
            } else {
                $session->setFlashdata('msg', 'El correo ingresado no existe.');
                return redirect()->to(base_url('/'));
            }
        } else {
            $data['validation'] = $this->validator;
            echo view('login/index', $data);
        }
    }

    public function forgot()
    {
        helper(['form']);
        $rules = [
            'email'         => [
                'label' => 'correo',
                'rules' => 'required|min_length[4]|max_length[100]|valid_email',
                'errors' => [
                    'required' => 'El campo {field} es requerido',
                    'min_length' => 'El campo {field} debe tener una longitud mínima de {param} caracteres.',
                    'min_length' => 'El campo {field} debe tener una longitud máxima de {param} caracteres',
                    'valid_email' => 'El correo ingresado es inválido.',
                ],
            ]
        ];

        if ($this->validate($rules)) {
            $session = session();
            $emailUser = $this->request->getPost('email', FILTER_SANITIZE_EMAIL);
            $userModel =  new Usuarios();

            $data = $userModel->where('user_email', $emailUser)->first();

            if (!empty($data)) {
                $email = \Config\Services::email();

                // $email->setFrom('no-reply@inndot.com', 'INNDOT - Piensa soluciones');
                $email->setFrom('soporte@kodit.com.mx', 'KODIT');
                $email->setTo($emailUser);

                $email->setSubject('Recuperar contraseña');
                $dt   = new Time('now', 'America/Mexico_City', 'es_MX');

                $data = [
                    "url_app" => base_url(),
                    "title" => "KODIT",
                    "url" => base_url('/recovery-password'),
                    "email" => $emailUser,
                    "date" => $dt
                ];

                $view = \Config\Services::renderer();

                $html = $view->setData($data, 'raw')->render('Mails/forgot', $data, true);

                $email->setMessage($html);

                if ($email->send()) {
                    $session->setFlashdata('msg_success', 'Se ha envíado el correo de recuperación a ' . $emailUser);
                    return redirect()->to(base_url('/forgot-password'));
                }

                exit();
            } else {
                $session->setFlashdata('msg', 'El correo ingresado no se encuentra en el sistema.');
                return redirect()->to(base_url('/forgot-password'));
            }
        } else {
            $data['validation'] = $this->validator;
            echo view('login/forgot-password', $data);
        }
    }

    public function recovery()
    {
        helper(['form']);
        $rules = [
            'email'         => [
                'label' => 'correo',
                'rules' => 'required|min_length[4]|max_length[100]|valid_email',
                'errors' => [
                    'required' => 'El campo {field} es requerido',
                    'min_length' => 'El campo {field} debe tener una longitud mínima de {param} caracteres.',
                    'min_length' => 'El campo {field} debe tener una longitud máxima de {param} caracteres',
                    'valid_email' => 'El correo ingresado es inválido.',
                ],
            ],
            'pass'      => [
                'label' => 'contraseña',
                'rules' => 'required|min_length[4]|max_length[50]',
                'errors' => [
                    'required' => 'El campo {field} es requerido',
                    'min_length' => 'El campo {field} debe tener una longitud mínima de {param} caracteres.',
                    'min_length' => 'El campo {field} debe tener una longitud máxima de {param} caracteres',
                ],
            ],
            'confirm_pass'      => [
                'label' => 'confirmar contraseña',
                'rules' => 'required|min_length[4]|max_length[50]|matches[pass]',
                'errors' => [
                    'required' => 'El campo {field} es requerido',
                    'min_length' => 'El campo {field} debe tener una longitud mínima de {param} caracteres.',
                    'min_length' => 'El campo {field} debe tener una longitud máxima de {param} caracteres',
                    'matches' => 'Las contraseñas no coinciden.'
                ],
            ]
        ];

        $session = session();
        if ($this->validate($rules)) {
            $emailUser = $this->request->getPost('email', FILTER_SANITIZE_EMAIL);
            $userModel =  new Usuarios();
            $userModel->set('password', password_hash($this->request->getPost('pass'), PASSWORD_DEFAULT));
            $userModel->where('user_email', $emailUser);

            $userModel->update();
            return redirect()->to(base_url('/'));
        } else {
            $session->setFlashdata('validation', $this->validator->listErrors());
            return redirect()->to($this->request->getPost('url_recovery'));
        }
    }

    public function logout()
    {
        $session = session();
        $session->destroy();

        return redirect()->to(base_url('/'));
    }
}
