<?php

namespace App\Models\Seguridad;

use CodeIgniter\Model;

class Usuarios extends Model
{
    protected $DBGroup              = 'default';
    protected $table                = 'users';
    protected $primaryKey           = 'user_id';


    protected $allowedFields = [        
        "nombre",
        "rol_id",
        "correo",
        "posicion_id",
        "bu_id",
        "estatus_id",
        "empresa",
        "tipocontrato_id",
        "costohoraorigen",
        "costohoraproveedor",
        "costohoratotal",
        "creado_por",
        "password",
        "esenviado"
    ];

    /**
     * Lista los registros
     */
    public function listar()
    {
        $Model = $this->db
                    ->table($this->table)
                    ->select('users.*');
                    
        return $Model->get()->getResult();
    }

    /**
     * Inserta un nuevo registro
     */
    public function insertar($datos)
    {
        $Model = $this->db->table($this->table);
        $Model->insert($datos);

        return $this->db->insertID();
    }

    /**
     * Actualiza un registro
     */
    public function actualizar($data, $id)
    {
        $Model = $this->db->table($this->table);
        $Model->set($data);
        $Model->where('user_id', $id);
        return $Model->update();
    }

    /**
     * Elimina el registro
     */
    public function eliminar($data)
    {
        $Model = $this->db->table($this->table);
        $Model->where($data);
        return $Model->delete();
    }

    public function get_usuario_correo($correo)
    {
        $Model = $this->db->query("SELECT users.user_email FROM users
                                    WHERE users.user_email = '$correo'")->getResultArray();

        return $Model[0];
    }
}
