<?= $this->extend('layouts/main'); ?>

<?php

$limitPagePerPaginate = 6;
$initialDayOfMonth = $initial;
$endDayOfMonth = $end;

?>

<?= $this->section('styles'); ?>

<!--SWEET ALERT CSS-->
<link href="<?php echo base_url('assets/plugins/sweet-alert/sweetalert.css'); ?>" rel="stylesheet" />

<!-- DATA TABLE CSS -->
<link href="<?php echo base_url('assets/plugins/datatable/css/dataTables.bootstrap5.min.css'); ?>" rel="stylesheet" />
<link href="<?php echo base_url('assets/plugins/datatable/css/fixedColumns.dataTables.min.css'); ?>" rel="stylesheet" />

<link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/buttons/2.1.0/css/buttons.dataTables.min.css" />

<!--BOOTSTRAP-DATERANGEPICKER CSS-->
<link rel="stylesheet" href="<?php echo base_url('assets/plugins/bootstrap-daterangepicker/daterangepicker.css'); ?>">

<!-- DATE PICKER CSS -->
<link href="<?php echo base_url('assets/plugins/date-picker/spectrum.css'); ?>" rel="stylesheet" />

<?= $this->endSection('styles'); ?>

<?= $this->section('page-header'); ?>

<div>
    <h1 class="page-title">Documentos</h1>
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="<?= base_url('/') ?>">Home</a></li>
        <li class="breadcrumb-item active" aria-current="page">Documentos</li>
    </ol>
</div>

<?= $this->endSection('page-header'); ?>

<?= $this->section('content'); ?>

<?php // if (validate_permissions(Session()->get('rol_id'), 8, ActionsEnums::CREAR)) : 
?>
<button type="button" class="btn btn-primary mb-3" data-bs-toggle="modal" data-bs-target="#exampleModal3">Agregar</button>
<?php // endif; 
?>
<?php // if(validate_permissions(session()->get('rol_id'), 8, ActionsEnums::CREAR)) : 
?>
<!-- <button type="button" class="btn btn-primary mb-3 float-end" data-bs-toggle="modal" data-bs-target="#exampleModal4">Carga masiva</button> -->
<?php // endif; 
?>

<?php if (session()->getFlashdata('errors')) : ?>
    <div class="alert alert-danger text-center" role="alert">
        <h4 class="fw-bold">¡Error!</h4>
        <ul>
            <?php foreach (session()->getFlashdata('errors') as $error) : ?>
                <li><?php echo $error ?></li>
            <?php endforeach ?>
        </ul>
    </div>
<?php endif;  ?>
<?php if (session()->getFlashdata('msg-success')) : ?>
    <div class="alert alert-success text-center" role="alert">
        <?= session()->getFlashdata('msg-success') ?>
    </div>
<?php endif;  ?>
<?php if (session()->getFlashdata('msg-error')) : ?>
    <div class="alert alert-danger text-center" role="alert">
        <?= session()->getFlashdata('msg-error') ?>
    </div>
<?php endif;  ?>
<!-- ROW-1 OPEN -->
<div class="row">
    <div class="col-md-12 col-lg-12">
        <div class="card">
            <div class="card-header">
                <h3 class="card-title">Documentos</h3>
            </div>
            <div class="card-body ">
                <form method="GET" action="<?php echo base_url() . '/documents/filtrarRangoFecha' ?>">
                    <div class="row">
                        <div class="col-md-6 col-lg-4 col-12">
                            <div class="w-100 input-group mb-2">
                                <div class="input-group-text">
                                    <i class="fa fa-calendar"></i>
                                </div>
                                <input type="text" class="form-control pull-right" value="<?= $initialDayOfMonth->format('Y-m-d') . ' - ' . $endDayOfMonth->format('Y-m-d') ?>" name="rangoFecha" id="reservation">
                            </div>
                        </div>
                        <div class="col-md-6 col-lg-3 col-12">
                            <div class="w-100 input-group mb-2">
                                <div class="input-group-text">
                                    <i class="fa fa-search"></i>
                                </div>
                                <input type="text" autocomplete="off" class="form-control pull-right" placeholder="Buscar por ..." value="<?= $filter ?>" name="filter" id="searching">
                            </div>
                        </div>
                        <div class="col-md-12 col-lg-2 col-12 text-center mb-2 d-flex justify-content-center">
                            <button class="btn btn-primary mr-1" type="submit">Filtrar</button>
                            <a class="btn btn-default" href="<?= base_url() . '/documents' ?>">Cancelar</a>
                        </div>
                    </div>
                </form>
                <div class="table-responsive">
                    <table id="example" class="table table-striped table-bordered text-nowrap w-100">
                        <thead class="thead-dark">
                            <tr>
                                <th class="wd-15p">Usuario</th>
                                <th>URL</th>
                                <th>Titulo</th>
                                <th>Tipo</th>
                                <th class="wd-5p not-export-col"></th>
                                <!-- <th class="wd-5p not-export-col"></th>
                                <th class="wd-5p not-export-col"></th> -->
                            </tr>
                        </thead>
                        <tbody>
                            <?php foreach ($requests as $request) : ?>
                                <tr>
                                    <td> <?= $request['user'] ?> </td>
                                    <td> <?= $request['url'] ?> </td>
                                    <td> <?= $request['title'] ?> </td>
                                    <td> <?= $request['type'] ?> </td>
                                    <!-- <td class="not-export-col">
                                        <a style="cursor:pointer;" class="fs-5 text-orange" data-bs-toggle="modal" data-bs-target="#modalEditar" data-bs-id="<?= $request->request_id; ?>" data-bs-user="<?= $request->user; ?>" data-bs-url="<?= $request->url; ?>">
                                            <i data-bs-toggle="tooltip" data-bs-placement="top" title="Editar" class="fa fa-edit"></i>
                                        </a>
                                    </td> -->
                                    <td class="text-center not-export-col">
                                        <form method="GET" action="<?php echo base_url() . '/documents/download_document' ?>" id="formDownload">
                                            <input type="hidden" value="<?= $request['url']; ?>" name="url">
                                            <input type="hidden" value="<?= $request['user']; ?>" name="user">
                                            <button type="submit" class="text-danger fs-5" style="border: 0; background: transparent;" id="btndownload"><i data-bs-toggle="tooltip" data-bs-placement="top" title="Descargar" class="fa fa-download"></i></button>
                                        </form>
                                        <!-- <a id="btndownload" style="cursor: pointer;" class="text-danger fs-5" data-bs-baseurl="<?= base_url() ?>" data-bs-url="<?= $request['url']; ?>" data-bs-user="<?= $request['user']; ?>"><i data-bs-toggle="tooltip" data-bs-placement="top" title="Descargar" class="fa fa-download"></i></a>  -->
                                    </td>
                                </tr>
                            <?php endforeach; ?>
                        </tbody>
                    </table>
                </div>
                <div class="pagination-wrapper">
                    <nav aria-label="Page navigation">
                        <?php
                        $criteria = "&rangoFecha=" . $initialDayOfMonth->format('Y-m-d') . ' - ' . $endDayOfMonth->format('Y-m-d');
                        $criteria = $criteria . ($filter != "" ? "&filter=" . urlencode($filter) : '');
                        $path = base_url() . '/documents/filtrarRangoFecha'; //'./' . $pager['uri']->segments[1] . '/filtrarRangoFecha';
                        ?>
                        <ul class="pagination mb-0">
                            <?php if ($pager['currentPage'] > 1) : ?>
                                <li class="page-item">
                                    <a href="<?= $path . '?page=1' . $criteria ?>" class="page-link" aria-label="<?= 'Primero' ?>">
                                        <span aria-hidden="true">Primero</span>
                                    </a>
                                </li>
                                <?php if (($pager['currentPage'] > 2) && $limitPagePerPaginate < $pager['pageCount']) : ?>
                                    <li class="page-item">
                                        <a href="<?= $path . '?page=' . ($pager['currentPage'] - 1) . $criteria ?>" class="page-link" aria-label="<?= 'Anterior' ?>">
                                            <?= ($pager['currentPage'] > 2) ? '...' : 'Anterior' ?>
                                        </a>
                                    </li>
                                <?php endif ?>

                            <?php endif ?>

                            <?php $MaxCount = 0;
                            if (($pager['currentPage'] + $limitPagePerPaginate) <= $pager['pageCount'] && $pager['pageCount'] > $pager['currentPage']) :
                                for ($page = $pager['currentPage']; $page <= $pager['pageCount']; $page++) : ?>
                                    <?php if ($MaxCount < $limitPagePerPaginate && ($MaxCount + $pager['currentPage']) < $pager['pageCount']) : ?>
                                        <li class="page-item <?= $pager['currentPage'] == $page ? 'active' : '' ?>">
                                            <a href="<?= $pager['currentPage'] != $page ? $path . '?page=' . $page  . $criteria : 'javascript:void(0)' ?>" class="page-link">
                                                <?= ($MaxCount == ($limitPagePerPaginate - 1)) ? '...' : $page ?>
                                            </a>
                                        </li>
                                    <?php else : break; ?>
                                    <?php endif ?>
                                <?php $MaxCount++;
                                endfor;
                            endif;

                            if (($pager['currentPage'] + $limitPagePerPaginate) > $pager['pageCount'] && $pager['currentPage'] >= 1) :
                                $MaxCount = 0;
                                $initialPage = $limitPagePerPaginate > $pager['pageCount'] ? 1 : $pager['pageCount'] - ($limitPagePerPaginate - 1);
                                for ($page = $initialPage; $page <= $pager['pageCount']; $page++) : ?>
                                    <?php if ($MaxCount < $limitPagePerPaginate && ($MaxCount + $initialPage) < $pager['pageCount']) : ?>
                                        <li class="page-item <?= $pager['currentPage'] == $page ? 'active' : '' ?>">
                                            <a href="<?= $pager['currentPage'] != $page ? $path . '?page=' . $page  . $criteria : 'javascript:void(0)' ?>" class="page-link">
                                                <?= ($MaxCount == ($limitPagePerPaginate - 1)) ? '...' : $page ?>
                                            </a>
                                        </li>
                                    <?php else : break; ?>
                                    <?php endif ?>

                            <?php $MaxCount++;
                                endfor;
                            endif
                            ?>

                            <?php if ($pager['currentPage'] <= $pager['pageCount']) : ?>
                                <li class="page-item <?= $pager['currentPage'] == $pager['pageCount'] ? 'active' : '' ?>">
                                    <a href="<?= $path . '?page=' . $pager['pageCount']  . $criteria ?>" aria-label="<?= 'Ultimo' ?>" class="page-link">
                                        <span aria-hidden="true"><?= $pager['pageCount'] ?></span>
                                    </a>
                                </li>
                                <?php if ($pager['currentPage'] < $pager['pageCount']) : ?>
                                    <li class="page-item">
                                        <a href="<?= $path . '?page=' . ($pager['currentPage'] + 1)  . $criteria ?>" aria-label="<?= 'Siguiente' ?>" class="page-link">
                                            Siguiente
                                        </a>
                                    </li>
                                <?php endif ?>
                            <?php endif ?>
                        </ul>
                    </nav>
                </div>
            </div>
            <!-- TABLE WRAPPER -->
        </div>
        <!-- SECTION WRAPPER -->
    </div>
</div>
<!-- ROW-1 CLOSED -->

<!-- MESSAGE MODAL -->
<div class="modal fade" id="exampleModal3" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <form method="GET" action="<?php echo base_url() . '/documents/generate_document' ?>" id="formCreate">
                <div class="modal-header">
                    <h5 class="modal-title" id="example-Modal3">Nuevo documento</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="alert alert-danger text-center" style="display:none;" id="alert-error" role="alert">
                        <h4 class="fw-bold">¡Error!</h4>
                        <ul id="content-error">

                        </ul>
                    </div>
                    <div class="mb-3">
                        <label class="form-label">URL</label>
                        <input type="text" class="form-control" autocomplete="off" name="url" id="url" maxlength="100" placeholder="Ingrese la URL">
                    </div>
                    <div class="mb-2">
                        <label for="id_type" class="form-control-label">Tipo</label>
                        <select class="form-control select2-show-search" name="id_type" id="id_type" style="width: 100% !important;" data-placeholder="Seleccione o busque el tipo requerido">
                            <?php foreach ($types as $key) : ?>
                                <option value="<?= $key->id ?>"><?= $key->type ?></option>
                            <?php endforeach; ?>
                        </select>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cerrar</button>
                    <button type="submit" class="btn btn-primary" id="btnCreate">Guardar</button>
                </div>
            </form>
        </div>
    </div>
</div>
<!-- MESSAGE MODAL CLOSED -->

<!-- MESSAGE MODAL -->
<div class="modal fade" id="modalEditar" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <form method="GET" action="<?php echo base_url() . '/documents/editar_document' ?>" id="formEdit">
                <div class="modal-header">
                    <h5 class="modal-title" id="example-Modal3">Editar documento</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <div class="alert alert-danger text-center" style="display:none;" id="alert-error" role="alert">
                        <h4 class="fw-bold">¡Error!</h4>
                        <ul id="content-error">

                        </ul>
                    </div>
                    <input type="text" class="form-control" name="idUpdate" id="idUpdate" hidden="">
                    <div class="mb-3">
                        <label class="form-label">URL</label>
                        <input type="text" class="form-control" autocomplete="off" name="urlUpdate" id="urlUpdate" maxlength="100" placeholder="Ingrese la URL">
                    </div>
                    <div class="mb-2">
                        <label for="id_typeupdate" class="form-control-label">Tipo</label>
                        <select class="form-control select2-show-search" name="id_typeupdate" id="id_typeupdate" style="width: 100% !important;" data-placeholder="Seleccione o busque el tipo requerido">
                            <?php foreach ($types as $key) : ?>
                                <option value="<?= $key->id ?>"><?= $key->type ?></option>
                            <?php endforeach; ?>
                        </select>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cerrar</button>
                    <button type="submit" class="btn btn-primary" id="btnEditar">Actualizar</button>
                </div>
            </form>
        </div>
    </div>
</div>
<!-- MESSAGE MODAL CLOSED -->

<?= $this->endSection('content'); ?>

<?= $this->section('scripts'); ?>

<!-- SWEET-ALERT JS -->
<script src="https://unpkg.com/sweetalert/dist/sweetalert.min.js"></script>
<!-- <script src="<?php echo base_url('assets/plugins/sweet-alert/sweetalert.min.js'); ?>"></script> -->
<script src="<?php echo base_url('assets/js/sweet-alert.js'); ?>"></script>

<!-- DATA TABLE JS-->
<script src="<?php echo base_url('assets/plugins/datatable/js/jquery.dataTables.min.js'); ?>"></script>
<script src="<?php echo base_url('assets/plugins/datatable/js/dataTables.bootstrap5.min.js'); ?>"></script>
<script src="<?php echo base_url('assets/plugins/datatable/dataTables.responsive.min.js'); ?>"></script>
<script src="<?php echo base_url('assets/plugins/datatable/dataTables.fixedColumns.min.js'); ?>"></script>

<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/jszip/2.5.0/jszip.min.js"></script>
<script type="text/javascript" src="https://cdn.datatables.net/buttons/2.1.0/js/dataTables.buttons.min.js"></script>
<script type="text/javascript" src="https://cdn.datatables.net/buttons/2.1.0/js/buttons.html5.min.js"></script>

<!-- BOOTSTRAP-DATERANGEPICKER JS -->
<script src="<?php echo base_url('assets/plugins/bootstrap-daterangepicker/moment.min.js'); ?>"></script>
<script src="<?php echo base_url('assets/plugins/bootstrap-daterangepicker/daterangepicker.js'); ?>"></script>

<!-- TIMEPICKER JS -->
<script src="<?php echo base_url('assets/plugins/time-picker/jquery.timepicker.js'); ?>"></script>
<script src="<?php echo base_url('assets/plugins/time-picker/toggles.min.js'); ?>"></script>

<!-- DATEPICKER JS -->
<script src="<?php echo base_url('assets/plugins/date-picker/spectrum.js'); ?>"></script>
<script src="<?php echo base_url('assets/plugins/date-picker/jquery-ui.js'); ?>"></script>
<script src="<?php echo base_url('assets/plugins/input-mask/jquery.maskedinput.js'); ?>"></script>


<script>
    $(document).ready(function() {

        //Date range picker
        $('#reservation').daterangepicker({
            locale: {
                format: 'YYYY-MM-DD'
            }
        });

        $('#example').DataTable({
            scrollX: true,
            scrollCollapse: true,
            paging: false,
            searching: false,
            ordering: false,
            // fixedColumns: {
            //     left: fixed,
            //     right: (canUpdate + canDelete + canSendEmail)
            // },
            dom: 'Bfrtip',
            buttons: [{
                extend: 'excel',
                text: 'Descargar xls',
                filename: `Certificados`,
                className: 'btn btn-primary',
                exportOptions: {
                    columns: ':visible:not(.not-export-col)'
                },
                action: function(e, dt, button, config) {
                    let data = dt.buttons.exportData();

                    window.open("<?= base_url() . '/documents/document_xlsx' ?>?rangoFecha=" + $("#reservation").val() + "&filter=" + $("#searching").val(), '_blank');

                }
            }],
        });

        // $("#example_filter > label").html("");
        $('#example_info').html('Mostrando la página <?= $pager['currentPage'] ?> de <?= $pager['pageCount'] ?> de <?= $pager['total'] ?> registro(s)');
    })
    const idUpdate = $("#idUpdate");
    const userUpdate = $("#userUpdate");
    const urlUpdate = $("#urlUpdate");

    const modalEditar = document.getElementById('modalEditar')
    modalEditar.addEventListener('show.bs.modal', function(event) {
        const button = event.relatedTarget

        const id = button.getAttribute('data-bs-id')
        const user = button.getAttribute("data-bs-user");
        const url = button.getAttribute("data-bs-url");

        idUpdate.val(id);
        userUpdate.val(user);
        urlUpdate.val(url);
    })

    $("#btnCreate").click(function() {
        const loading = $("#global-loader");
        setTimeout(() => {
            loading.hide();
        }, 10000);
    })

    $("#btnEditar").click(function() {
        const loading = $("#global-loader");
        setTimeout(() => {
            loading.hide();
        }, 10000);
    })

    $("#btndownload").click(function(e) {
        const loading = $("#global-loader");
        setTimeout(() => {
            loading.hide();
        }, 10000);
    })
</script>

<?= $this->endSection('scripts'); ?>