<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
    <title>Welcome to CodeIgniter 4!</title>
    <meta name="description" content="The small framework with powerful features">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <link rel="shortcut icon" type="image/png" href="/favicon.ico" />
    <!-- <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@5.2.2/dist/css/bootstrap.min.css" integrity="sha384-Zenh87qX5JnK2Jl0vWa8Ck2rdkQ2Bzep5IDxbcnCeuOxjzrPF/et3URy9Bv1WTRi" crossorigin="anonymous"> -->
    <script src="https://cdn.jsdelivr.net/npm/bootstrap@5.2.2/dist/js/bootstrap.min.js" integrity="sha384-IDwe1+LCz02ROU9k972gdyvl+AESN10+x7tBKgc9I5HFtuNz0wWnPclzo6p9vxnk" crossorigin="anonymous"></script>
    <!-- STYLES -->

    <style {csp-style-nonce}>
        * {
            transition: background-color 300ms ease, color 300ms ease;
        }

        *:focus {
            background-color: rgba(221, 72, 20, .2);
            outline: none;
        }

        html,
        body {
            color: rgba(33, 37, 41, 1);
            font-family: -apple-system, BlinkMacSystemFont, "Segoe UI", Helvetica, Arial, sans-serif, "Apple Color Emoji", "Segoe UI Emoji";
            font-size: 16px;
            margin: 0;
            padding: 0;
            -webkit-font-smoothing: antialiased;
            -moz-osx-font-smoothing: grayscale;
            text-rendering: optimizeLegibility;
        }

        .row {
            --bs-gutter-x: 1.5rem;
            --bs-gutter-y: 0;
            width: 100%;
            display: inline-block;
            flex-wrap: wrap;
            margin-top: calc(-1 * var(--bs-gutter-y));
            margin-right: calc(-.5 * var(--bs-gutter-x));
            margin-left: calc(-.5 * var(--bs-gutter-x));
        }

        .text-center {
            text-align: center !important;
        }

        .col-2 {
            /* flex: 0 0 auto; */
            width: 16.66666667%;
        }

        .col-10 {
            /* flex: 0 0 auto; */
            width: 83.33333333%;
        }

        .col-1 {
            flex: 0 0 auto;
            width: 8.33333333%;
        }

        .col-11 {
            flex: 0 0 auto;
            width: 91.66666667%;
        }

        .col-6 {
            flex: 0 0 auto;
            width: 50%;
        }

        .text-white {
            color: white;
        }

        .menu {
            padding: .4rem 2rem;
        }

        header ul {
            border-bottom: 1px solid rgba(242, 242, 242, 1);
            list-style-type: none;
            margin: 0;
            overflow: hidden;
            padding: 0;
            text-align: right;
        }

        header li {
            display: inline-block;
        }

        header li a {
            border-radius: 5px;
            color: rgba(0, 0, 0, .5);
            display: block;
            height: 44px;
            text-decoration: none;
        }

        header li.menu-item a {
            border-radius: 5px;
            margin: 5px 0;
            height: 38px;
            line-height: 36px;
            padding: .4rem .65rem;
            text-align: center;
        }

        header li.menu-item a:hover,
        header li.menu-item a:focus {
            background-color: rgba(221, 72, 20, .2);
            color: rgba(221, 72, 20, 1);
        }

        header .logo {
            float: left;
            height: 44px;
            padding: .4rem .5rem;
        }

        header .menu-toggle {
            display: none;
            float: right;
            font-size: 2rem;
            font-weight: bold;
        }

        header .menu-toggle button {
            background-color: rgba(221, 72, 20, .6);
            border: none;
            border-radius: 3px;
            color: rgba(255, 255, 255, 1);
            cursor: pointer;
            font: inherit;
            font-size: 1.3rem;
            height: 36px;
            padding: 0;
            margin: 11px 0;
            overflow: visible;
            width: 40px;
        }

        header .menu-toggle button:hover,
        header .menu-toggle button:focus {
            background-color: rgba(221, 72, 20, .8);
            color: rgba(255, 255, 255, .8);
        }

        header .heroe {
            margin: 0 auto;
            max-width: 1100px;
            padding: 1rem 1.75rem 1.75rem 1.75rem;
        }

        header .heroe h1 {
            font-size: 2.5rem;
            font-weight: 500;
        }

        header .heroe h2 {
            font-size: 1.5rem;
            font-weight: 300;
        }

        section {
            margin: 0 auto;
            max-width: 1100px;
            padding: 2.5rem 1.75rem 3.5rem 1.75rem;
        }

        section h1 {
            margin-bottom: 2.5rem;
        }

        section h2 {
            font-size: 120%;
            line-height: 2.5rem;
            padding-top: 1.5rem;
        }

        section pre {
            background-color: rgba(247, 248, 249, 1);
            border: 1px solid rgba(242, 242, 242, 1);
            display: block;
            font-size: .9rem;
            margin: 2rem 0;
            padding: 1rem 1.5rem;
            white-space: pre-wrap;
            word-break: break-all;
        }

        section code {
            display: block;
        }

        section a {
            color: rgba(221, 72, 20, 1);
        }

        section svg {
            margin-bottom: -5px;
            margin-right: 5px;
            width: 25px;
        }

        .further {
            background-color: rgba(247, 248, 249, 1);
            border-bottom: 1px solid rgba(242, 242, 242, 1);
            border-top: 1px solid rgba(242, 242, 242, 1);
        }

        .further h2:first-of-type {
            padding-top: 0;
        }

        footer {
            background-color: rgb(204, 34, 30);
            text-align: center;
        }

        footer .environment {
            color: rgba(255, 255, 255, 1);
            padding: 2rem 1.75rem;
        }

        footer .copyrights {
            background-color: rgba(62, 62, 62, 1);
            color: rgba(200, 200, 200, 1);
            padding: .25rem 1.75rem;
        }

        @media (max-width: 629px) {
            header ul {
                padding: 0;
            }

            header .menu-toggle {
                padding: 0 1rem;
            }

            header .menu-item {
                background-color: rgba(244, 245, 246, 1);
                border-top: 1px solid rgba(242, 242, 242, 1);
                margin: 0 15px;
                width: calc(100% - 30px);
            }

            header .menu-toggle {
                display: block;
            }

            header .hidden {
                display: none;
            }

            header li.menu-item a {
                background-color: rgba(221, 72, 20, .1);
            }

            header li.menu-item a:hover,
            header li.menu-item a:focus {
                background-color: rgba(221, 72, 20, .7);
                color: rgba(255, 255, 255, .8);
            }
        }

        .page_break {
            page-break-before: always;
            text-align: ;
        }
    </style>
</head>

<body>

    <!-- HEADER: MENU + HEROE SECTION -->
    <header>
        <?php
        $path = './Kodit.png';
        $type = pathinfo($path, PATHINFO_EXTENSION);
        $data_img = file_get_contents($path);
        $base64 = 'data:image/' . $type . ';base64,' . base64_encode($data_img);

        $path_top1 = './top_1.png';
        $type = pathinfo($path_top1, PATHINFO_EXTENSION);
        $data_img = file_get_contents($path_top1);
        $base64_top1 = 'data:image/' . $type . ';base64,' . base64_encode($data_img);

        $path_top2 = './top_2.png';
        $type = pathinfo($path_top2, PATHINFO_EXTENSION);
        $data_img = file_get_contents($path_top2);
        $base64_top2 = 'data:image/' . $type . ';base64,' . base64_encode($data_img);
        ?>
        <table style="width: 100%;" border="0" cellspacing="0" cellpadding="0">
            <tr>
                <td rowspan="2" style="text-align: center;background: #E4E4E4;">
                    <img height="44" title="Kodit Logo" alt="Visita Kodit.com.mx oficial sitio web!" src="<?= $base64 ?>">
                </td>
                <td style="text-align: center;background: #892D32; color:white"><b>ACTA DE REPORTE DE HALLAZGO</b></td>
            </tr>
            <tr>
                <td style="text-align: center;background: #761E2A; color:white"><b><?= date('Y-m-d') ?></b></td>
            </tr>
        </table>
        <!-- <div class="row" style="background: #E4E4E4;width: 100%;display: inline-block;">
            <div class="col-2 text-center" style="
                display: inline-block;
                float: left;
            ">
                <img height="44" title="Kodit Logo" alt="Visita Kodit.com.mx oficial sitio web!" src="<?= $base64 ?>">
            </div>
            <div class="col-10" style="
                display: inline-block;
                float: left;
            ">
                <div class="row" style="
                width: 100%;
            ">
                    <div class="col-1" style="height: 38px;background: url('<?= base_url('./top_1.png'); ?>');
                    /** float:left;background: linear-gradient(to top right, #E4E4E4 0%, #E4E4E4 50%, #892D32 50%, #892D32 100%); **/
                    "
                    >
                    <img  title="Kodit Logo" alt="Visita Kodit.com.mx oficial sitio web!" src="<?= base_url('./top_1.png'); ?>">
                    </div>
                    <div class="col-11  text-center" style="background: #892D32; color:white"><b>ACTA DE REPORTE DE HALLAZGO</b></div>
                    <div class="col-1" style="
                    float:right;background: linear-gradient(to bottom right, #E4E4E4 0%, #E4E4E4 50%, #761E2A 50%, #761E2A 100%);
                    background-image: url('./top_2.png')"
                    ></div>
                    <div class="col-11  text-center" style="background: #761E2A; color:white"><b>2022-11-22</b></div>
                </div>
            </div>
        </div> -->
        <!-- <div class="row" style="background: #E4E4E4;">
            <div class="col-2 text-center">
                <img height="44" title="Kodit Logo" alt="Visita Kodit.com.mx oficial sitio web!" src="<?= $base64 ?>">
            </div>
            <div class="col-10">
                <div class="row">
                    <div class="col-1" style="float:left;background: linear-gradient(to top right, #E4E4E4 0%, #E4E4E4 50%, #892D32 50%, #892D32 100%);"></div>
                    <div class="col-11  text-center" style="background: #892D32; color:white"><b>ACTA DE REPORTE DE HALLAZGO</b></div>
                    <div class="col-1" style="float:right;background: linear-gradient(to bottom right, #E4E4E4 0%, #E4E4E4 50%, #761E2A 50%, #761E2A 100%);"></div>
                    <div class="col-11  text-center" style="background: #761E2A; color:white"><b><?= date('Y-m-d') ?></b></div>
                </div>
            </div>
        </div> -->

        <div class="heroe">
            <p>
                El usuario de la plataforma Kodit.com <b><?= strtoupper($data['user']) ?></b> solicitó certificar a fecha <?= $data['data_request'] ?>
                la siguiente URL:
                <br>
                <a href="<?= $data['url'] ?>"><?= $data['url'] ?></a>
            </p>
            <table style="width: 100%;" border="0" cellspacing="0" cellpadding="0">
                <tbody>
                    <tr>
                        <td style="background: #892D32;text-align: center; width: 50%; border-right: 5px white solid;">
                            <h6 class="text-white">FOLIO:</h6>
                            <h6 class="text-white"><?= $id ?></h6>
                        </td>
                        <td style="background: #30373F;text-align: center; width: 50%; border-left: 5px white solid;">
                            <h6 class="text-white">FECHA DE CAPTURA:</h6>
                            <h6 class="text-white"><?= $data['data_request'] ?></h6>
                        </td>
                    </tr>
                </tbody>
            </table>
            <!-- <div class="row">
                <div class="col-6 text-center">
                    <div class="row p-1">
                        <div class="col-12 py-2" style="background: #892D32;">
                            
                        </div>
                    </div>
                </div>
                <div class="col-6 text-center">
                    <div class="row p-1">
                        <div class="col-12 py-2" style="background: #30373F;">
                            <h6 class="text-white">FECHA DE CAPTURA:</h6>
                            <h6 class="text-white"><?= $data['data_request'] ?></h6>
                        </div>
                    </div>
                </div>
            </div> -->
        </div>

    </header>

    <!-- CONTENT -->

    <section style="background-color: #E4E4E2;">

        <table style="width: 100%;" border="0" cellspacing="0" cellpadding="0">
            <tbody>
                <tr>
                    <td><b>VERSIÓN (SHA256)</b></td>
                </tr>
                <tr>
                    <td style="border: 1px black solid;background: white"><?= $data['authentication'] ?></td>
                </tr>
                <tr>
                    <td><b>IP SOLICITANTE</b></td>
                </tr>
                <tr>
                    <td style="border: 1px black solid;background: white"><?= $ip_visitor ?></td>
                </tr>
            </tbody>
        </table>

    </section>
    <div class="page_break"></div>
    <div class="further">
        <section>
            <table style="width: 100%;" border="0" cellspacing="0" cellpadding="0">
                <tbody>
                    <tr>
                        <td style="width: 30%;"></td>
                        <td style="width: 30%;background: #892D32;text-align: center;">
                            <h6 class="text-white">EVIDENCIAS</h6>
                        </td>
                        <td style="width: 30%;"></td>
                    </tr>
                </tbody>
            </table>
            <!-- <div class="row">
                <div class="col align-self-center"></div>
                <div class="col align-self-center py-2 text-center" style="background: #892D32;">
                    <h6 class="text-white">EVIDENCIAS</h6>
                </div>
                <div class="col align-self-end"></div>
            </div> -->

            <br><br>

            <!-- <embed src="http://kodit.com.mx/" width="300" height="200"> -->
            <?php
            $googleApiKey = "AIzaSyBRuGmJw_Y-VcSK1baHe12-rVdVr3IF23U";
            $siteURL = $data['url'];
            $googlePagespeedData = file_get_contents("https://www.googleapis.com/pagespeedonline/v5/runPagespeed?url=$siteURL&screenshot=true&key=$googleApiKey");
            $googlePagespeedData = json_decode($googlePagespeedData, true);
            $screenshot_data = $googlePagespeedData['lighthouseResult']['audits']['final-screenshot']['details']['data'];

            echo '<img src="' . $screenshot_data . '" style="width:100%"/>';
            ?>

        </section>

        <section>
            <table style="width: 100%;" border="0" cellspacing="0" cellpadding="0">
                <tbody>
                    <tr>
                        <td style="width: 30%;"></td>
                        <td style="width: 30%;background: #892D32;text-align: center;">
                            <h6 class="text-white">CÓDIGO FUENTE</h6>
                        </td>
                        <td style="width: 30%;"></td>
                    </tr>
                </tbody>
            </table>
            <!-- <div class="row">
                <div class="col align-self-center"></div>
                <div class="col align-self-center py-2 text-center" style="background: #892D32;">
                    <h6 class="text-white">CÓDIGO FUENTE</h6>
                </div>
                <div class="col align-self-end"></div>
            </div> -->

            <br><br>
            <pre style="font-size: 6px;">
                <?= $html ?>
            </pre>
        </section>

    </div>

    <!-- FOOTER: DEBUG INFO + COPYRIGHTS -->

    <!-- SCRIPTS -->

    <script>
        function toggleMenu() {
            var menuItems = document.getElementsByClassName('menu-item');
            for (var i = 0; i < menuItems.length; i++) {
                var menuItem = menuItems[i];
                menuItem.classList.toggle("hidden");
            }
        }
    </script>

    <!-- -->

</body>

</html>