<?= $this->extend('layouts/main'); ?>
<?php
// helper('application');
// helper('number');
// Config('Config\\Enums\\ConfigsEnums');
// Config('Config\\Enums\\ActionsEnums');
// $categorias = ConfigsEnums::getList();
?>

<?= $this->section('styles'); ?>

<!-- DATA TABLE CSS -->
<link href="<?php echo base_url('assets/plugins/datatable/css/dataTables.bootstrap5.min.css'); ?>" rel="stylesheet" />
<link href="<?php echo base_url('assets/plugins/datatable/css/fixedColumns.dataTables.min.css'); ?>" rel="stylesheet" />

<link rel="stylesheet" type="text/css" href="https://cdn.datatables.net/buttons/2.1.0/css/buttons.dataTables.min.css" />


<?= $this->endSection('styles'); ?>

<?= $this->section('page-header'); ?>

<div>
    <h1 class="page-title">Usuarios</h1>
    <ol class="breadcrumb">
        <li class="breadcrumb-item"><a href="<?= base_url('/') ?>">Home</a></li>
        <li class="breadcrumb-item active" aria-current="page">Usuarios</li>
    </ol>
</div>

<?= $this->endSection('page-header'); ?>

<?= $this->section('content'); ?>

<?php // if (validate_permissions(Session()->get('rol_id'), 8, ActionsEnums::CREAR)) : 
?>
<button type="button" class="btn btn-primary mb-3" data-bs-toggle="modal" data-bs-target="#exampleModal3">Agregar</button>
<?php // endif; 
?>
<?php // if(validate_permissions(session()->get('rol_id'), 8, ActionsEnums::CREAR)) : 
?>
<!-- <button type="button" class="btn btn-primary mb-3 float-end" data-bs-toggle="modal" data-bs-target="#exampleModal4">Carga masiva</button> -->
<?php // endif; 
?>

<?php if (session()->getFlashdata('errors')) : ?>
    <div class="alert alert-danger text-center" role="alert">
        <h4 class="fw-bold">¡Error!</h4>
        <ul>
            <?php foreach (session()->getFlashdata('errors') as $error) : ?>
                <li><?php echo $error ?></li>
            <?php endforeach ?>
        </ul>
    </div>
<?php endif;  ?>
<?php if (session()->getFlashdata('msg-success')) : ?>
    <div class="alert alert-success text-center" role="alert">
        <?= session()->getFlashdata('msg-success') ?>
    </div>
<?php endif;  ?>
<?php if (session()->getFlashdata('msg-error')) : ?>
    <div class="alert alert-danger text-center" role="alert">
        <?= session()->getFlashdata('msg-error') ?>
    </div>
<?php endif;  ?>
<!-- ROW-1 OPEN -->
<div class="row">
    <div class="col-md-12 col-lg-12">
        <div class="card">
            <div class="card-header">
                <h3 class="card-title">Usuarios</h3>
            </div>
            <div class="card-body ">
                <div class="table-responsive">
                    <table id="example" class="table table-striped table-bordered text-nowrap w-100">
                        <thead class="thead-dark">
                            <tr>
                                <th class="wd-15p">Persona</th>
                                <th>Estatus</th>
                                <th>Correo</th>
                                <?php // if (validate_permissions(Session()->get('rol_id'), 8, ActionsEnums::EDITAR)) : 
                                ?>
                                <th class="wd-5p not-export-col"></th>
                                <?php // endif; 
                                ?>
                                <?php // if (validate_permissions(Session()->get('rol_id'), 8, ActionsEnums::ELIMINAR)) : 
                                ?>
                                <th class="wd-5p not-export-col"></th>
                                <?php // endif; 
                                ?>
                                <?php // if (validate_permissions(Session()->get('rol_id'), 8, ActionsEnums::CREAR) || validate_permissions(Session()->get('rol_id'), 8, ActionsEnums::EDITAR)) : 
                                ?>
                                <th class="wd-5p not-export-col"></th>
                                <?php // endif; 
                                ?>
                            </tr>
                        </thead>
                        <tbody>
                            <?php foreach ($usuarios as $usuario) : ?>
                                <tr>
                                    <td> <?= $usuario->user_name ?> </td>
                                    <td class="text-center"> <strong class="text-<?= $usuario->status == 1 ? 'success' : 'danger' ?>"><?= $usuario->status == 1 ? 'Activo' : 'Inactivo' ?></strong> </td>
                                    <td> <?= $usuario->user_email ?> </td>
                                    <td>
                                        <a style="cursor:pointer;" class="fs-5 text-orange" data-bs-toggle="modal" data-bs-target="#modalEditar" data-bs-id="<?= $usuario->user_id; ?>" data-bs-nombre="<?= $usuario->user_name; ?>" data-bs-estatus="<?= $usuario->status; ?>" data-bs-correo="<?= $usuario->user_email; ?>">
                                            <i data-bs-toggle="tooltip" data-bs-placement="top" title="Editar" class="fa fa-edit"></i>
                                        </a>
                                    </td>
                                    <?php // if (validate_permissions(Session()->get('rol_id'), 8, ActionsEnums::ELIMINAR)) : 
                                    ?>
                                    <?php if ($usuario->status == 1) : ?>
                                        <td class="not-export-col"> <a href="<?php echo base_url() . '/usuarios/eliminar/' . $usuario->user_id; ?>" class="fs-5 text-danger" title="Inactivar para proyectos"><i data-bs-toggle="tooltip" data-bs-placement="top" title="Inactivar" class="fa fa-close"></i></a> </td>
                                    <?php else : ?>
                                        <td class="not-export-col"> <a href="<?php echo base_url() . '/usuarios/eliminar/' . $usuario->user_id; ?>" class="fs-5 text-success" title="Activar para proyectos"><i data-bs-toggle="tooltip" data-bs-placement="top" title="Activar" class="fa fa-check"></i></a> </td>
                                    <?php endif ?>
                                    <?php // endif; 
                                    ?>
                                    <?php // if (validate_permissions(Session()->get('rol_id'), 8, ActionsEnums::CREAR) || validate_permissions(Session()->get('rol_id'), 8, ActionsEnums::EDITAR)) : 
                                    ?>
                                    <?php //if (!$usuario->esEnviado) : 
                                    ?>
                                    <td class="not-export-col"> <a href="<?php echo base_url() . '/usuarios/email/' . $usuario->user_id; ?>" class="text-info" title="Enviar invitación"><i data-bs-toggle="tooltip" data-bs-placement="top" title="Enviar invitación" class="fa fa-paper-plane"></i></a> </td>
                                    <!-- <?php //else: 
                                            ?>
                                            <td class="text-center" title="Enviado"> <i data-bs-toggle="tooltip" data-bs-placement="top" title="Enviado" class="text-info fa fa-envelope-o fa-2x"></i> </td>
                                        <?php //endif 
                                        ?> -->

                                    <?php // endif; 
                                    ?>
                                </tr>
                            <?php endforeach; ?>
                        </tbody>
                    </table>
                </div>
            </div>
            <!-- TABLE WRAPPER -->
        </div>
        <!-- SECTION WRAPPER -->
    </div>
</div>
<!-- ROW-1 CLOSED -->

<!-- MESSAGE MODAL -->
<div class="modal fade" id="exampleModal3" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <form method="POST" action="<?php echo base_url() . '/usuarios/crear' ?>" id="formCreate">
                <div class="modal-header">
                    <h5 class="modal-title" id="example-Modal3">Nuevo usuario</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <input type="text" class="form-control" name="id" id="id" hidden="">
                    <div class="mb-3">
                        <label class="form-label">Persona</label>
                        <input type="text" class="form-control" autocomplete="off" name="nombre" id="nombre" maxlength="100" placeholder="Ingrese el nombre de la persona">
                    </div>
                    <div class="mb-3">
                        <label class="form-label">Estatus</label>
                        <select name="estatus_id" id="estatus_id" class="form-control custom-select">
                            <option value="1">Activo</option>
                            <option value="0">Inactivo</option>
                        </select>
                    </div>
                    <div class="mb-3">
                        <label class="form-label">Correo electrónico</label>
                        <input type="text" class="form-control" autocomplete="off" name="correo" id="correo" maxlength="100" placeholder="Ingrese el correo electrónico">
                    </div>
                </div>
                <div class=" modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cerrar</button>
                    <button type="submit" class="btn btn-primary" id="btnCreate">Guardar</button>
                </div>
            </form>
        </div>
    </div>
</div>
<!-- MESSAGE MODAL CLOSED -->

<!-- MESSAGE MODAL -->
<div class="modal fade" id="modalEditar" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <form method="POST" action="<?php echo base_url() . '/usuarios/actualizar' ?>">
                <div class="modal-header">
                    <h5 class="modal-title" id="example-Modal3">Editar usuario</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close">
                        <span aria-hidden="true">&times;</span>
                    </button>
                </div>
                <div class="modal-body">
                    <input type="text" class="form-control" name="idUpdate" id="idUpdate" hidden="">
                    <input type="text" class="form-control" name="esEnviadoUpdate" id="esEnviadoUpdate" hidden="">
                    <div class="mb-3">
                        <label class="form-label">Persona</label>
                        <input type="text" class="form-control" autocomplete="off" name="nombreUpdate" id="nombreUpdate" maxlength="100" placeholder="Ingrese el nombre de la persona">
                    </div>
                    <div class="mb-3">
                        <label class="form-label">Estatus</label>
                        <select name="estatus_idUpdate" id="estatus_idUpdate" class="form-control custom-select">
                            <option value="1">Activo</option>
                            <option value="0">Inactivo</option>
                        </select>
                    </div>
                    <div class="mb-3">
                        <label class="form-label">Correo electrónico</label>
                        <input type="text" class="form-control" autocomplete="off" name="correoUpdate" id="correoUpdate" maxlength="100" placeholder="Ingrese el correo electrónico">
                    </div>
                </div>
                <div class=" modal-footer">
                    <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cerrar</button>
                    <button type="submit" class="btn btn-primary">Actualizar</button>
                </div>
            </form>
        </div>
    </div>
</div>
<!-- MESSAGE MODAL CLOSED -->

<!-- MESSAGE MODAL -->
<div class="modal fade" id="exampleModal4" tabindex="-1" role="dialog" aria-hidden="true">
    <div class="modal-dialog" role="document">
        <div class="modal-content">
            <div class="modal-header">
                <h5 class="modal-title" id="example-Modal3">Carga masiva</h5>
                <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
            </div>
            <div class="modal-body">
                <div id="container">
                    <div class="row">
                        <div class="col-md-4 col-12">
                            <form method="POST" class="text-center" action="<?php echo base_url() . '/usuarios/usuarios_cvs' ?>">
                                <button type="submit" name="submitDescargar" class="btn btn-primary w-100" id="btnDescargarCVS">Descargar Plantilla</button>
                            </form>
                        </div>
                        <div class="col-md-8 col-12">
                            <form method="POST" class="row" action="<?php echo base_url() . '/usuarios/cvsimport' ?>" enctype="multipart/form-data">
                                <div class="col-md-8 text-center">
                                    <label class="btn btn-secondary w-100" for="file">Seleccionar archivo</label>
                                    <input type="file" style="display:none;" class="form-control" name="file" id="file" readonly>
                                </div>
                                <div class="col-md-4 text-center">
                                    <button type="submit" name="submit" class="btn btn-primary btn-md mb-1 w-100" id="btnGuardarCVS">Cargar</button>
                                </div>
                            </form>
                        </div>
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-secondary" data-bs-dismiss="modal">Cerrar</button>
            </div>
        </div>
    </div>
</div>
<!-- MESSAGE MODAL CLOSED -->

<?= $this->endSection('content'); ?>

<?= $this->section('scripts'); ?>

<!-- DATA TABLE JS-->
<script src="<?php echo base_url('assets/plugins/datatable/js/jquery.dataTables.min.js'); ?>"></script>
<script src="<?php echo base_url('assets/plugins/datatable/js/dataTables.bootstrap5.min.js'); ?>"></script>
<script src="<?php echo base_url('assets/plugins/datatable/dataTables.responsive.min.js'); ?>"></script>
<script src="<?php echo base_url('assets/plugins/datatable/dataTables.fixedColumns.min.js'); ?>"></script>

<script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/jszip/2.5.0/jszip.min.js"></script>
<script type="text/javascript" src="https://cdn.datatables.net/buttons/2.1.0/js/dataTables.buttons.min.js"></script>
<script type="text/javascript" src="https://cdn.datatables.net/buttons/2.1.0/js/buttons.html5.min.js"></script>

<script>
    const costohoraorigenCreate = $("#costohoraorigen");
    const costohoraproveedorCreate = $("#costohoraproveedor");

    // FORM UPDATE    
    const idUpdate = $("#idUpdate");
    const nombreUpdate = $("#nombreUpdate");
    const rol_idUpdate = $("#rol_idUpdate");
    const estatus_idUpdate = $("#estatus_idUpdate");
    const correoUpdate = $("#correoUpdate");
    const posicion_idUpdate = $("#posicion_idUpdate");
    const bu_idUpdate = $("#bu_idUpdate");
    const empresaUpdate = $("#empresaUpdate");
    const tipocontrato_idUpdate = $("#tipocontrato_idUpdate");
    const costohoraorigenUpdate = $("#costohoraorigenUpdate");
    const costohoraproveedorUpdate = $("#costohoraproveedorUpdate");
    const esEnviadoUpdate = $("#esEnviadoUpdate");


    $(document).ready(function() {
        let canUpdate = 0
        let canDelete = 0
        let canSendEmail = 0
        let fixed = 0
        if (screen.width >= 1024) {
            //fixed = 2
            canUpdate = parseInt("1");
            canDelete = parseInt("1");
            canSendEmail = parseInt("1");
        }

        $('#example').DataTable({
            scrollX: true,
            scrollCollapse: true,
            paging: true,
            fixedColumns: {
                left: fixed,
                right: (canUpdate + canDelete + canSendEmail)
            },
            dom: 'Bfrtip',
            buttons: [{
                extend: 'excel',
                text: 'Descargar xls',
                filename: `Usuarios - RRHH`,
                className: 'btn btn-primary',
                exportOptions: {
                    columns: ':visible:not(.not-export-col)'
                }
            }],
        });

        $("body").submit(function() {
            $("#global-loader").show();
        })
        $("#btnDescargarCVS").click(function() {
            const loading = $("#global-loader");
            setTimeout(() => {
                loading.css("display", "none");
            }, 3000);

        })

        window.onbeforeunload = function(e) {
            $("#global-loader").show();
        };
    });

    const modalEditar = document.getElementById('modalEditar')
    modalEditar.addEventListener('show.bs.modal', function(event) {
        const button = event.relatedTarget

        const id = button.getAttribute('data-bs-id')
        const nombre = button.getAttribute("data-bs-nombre");
        const rol_id = button.getAttribute("data-bs-rol");
        const estatus_id = button.getAttribute("data-bs-estatus");
        const correo = button.getAttribute("data-bs-correo");
        const posicion_id = button.getAttribute("data-bs-posicion");
        const bu_id = button.getAttribute("data-bs-bu");
        const empresa = button.getAttribute("data-bs-empresa");
        const tipocontrato_id = button.getAttribute("data-bs-tipocontrato");
        const costohoraorigen = button.getAttribute("data-bs-costohoraorigen");
        const costohoraproveedor = button.getAttribute("data-bs-costohoraproveedor");
        const esEnviado = button.getAttribute("data-bs-esEnviado");

        idUpdate.val(id);
        nombreUpdate.val(nombre);
        rol_idUpdate.val(rol_id);
        estatus_idUpdate.val(estatus_id);
        correoUpdate.val(correo);
        posicion_idUpdate.val(posicion_id);
        bu_idUpdate.val(bu_id);
        empresaUpdate.val(empresa);
        tipocontrato_idUpdate.val(tipocontrato_id);
        costohoraorigenUpdate.val(costohoraorigen);
        costohoraproveedorUpdate.val(costohoraproveedor);
        esEnviadoUpdate.val(esEnviado);

        calculateTotalHours("#costohoratotalUpdate");
    })

    const exampleModal3 = document.getElementById('exampleModal3')
    $("#exampleModal3").on('hidden.bs.modal', function(event) {
        $('form#formCreate').trigger("reset");
    })

    function acceptNum(evt, num) {
        let nav = window.Event ? true : false;
        let key = nav ? evt.which : evt.keyCode;

        if (num.value.includes(".")) {
            if (num.value.split('.')[1].length == 2) {
                return false;
            } else {
                return (key <= 13 || (key >= 48 && key <= 57));
            }
        } else {
            return (key <= 13 || (key >= 48 && key <= 57) || key == 46);
        }
    }

    function calculateTotalHours(id) {
        const total = (id.includes('Update')) ?
            (parseFloat((costohoraorigenUpdate.val() ? costohoraorigenUpdate.val() : '0')) + parseFloat((costohoraproveedorUpdate.val() ? costohoraproveedorUpdate.val() : '0'))) :
            (parseFloat((costohoraorigenCreate.val() ? costohoraorigenCreate.val() : '0')) + parseFloat((costohoraproveedorCreate.val() ? costohoraproveedorCreate.val() : '0')));
        $(id).val(Number(Math.round(total + 'e2') + 'e-2'));
    }
</script>

<?= $this->endSection('scripts'); ?>